
#include <X11/Xlib.h>
#include <string.h>
#include <time.h> 
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include "epda.h"

#define REFRESH 200000 	//time interval in usec to refresh display window

long long  calclock();

int main() {
	//Some Definitions for X-window
    Display *d ;
    Window   w, root ;
	Font f;
	GC gc;
	XSetWindowAttributes xswa;

	char msg0[100], msg1[100], msg2[100], msg3[100], mbf1[100], mbf2[100];

	struct   timeval  start_time, pre_time, cur_time, end_time;
	long long elapsedtime;
	int ctime1, ctime2,i;	
	char cmd[100];
	double stime,a;
	FILE *fo;


	//Set envirionments for X-window
    d = XOpenDisplay(NULL) ;
    root = XDefaultRootWindow (d);
    w = XCreateSimpleWindow ( d, root, 260, 110, 400, 100, 
        2, BlackPixel (d,0), WhitePixel(d,0) );
	XChangeWindowAttributes (d, w, CWOverrideRedirect, &xswa);
    XMapWindow (d, w);
	gc=XCreateGC(d,w,0L, (XGCValues *) NULL);
	f=XLoadFont (d,"fixed");
	XSetFont (d,gc,f);

	//set the starting time
	gettimeofday(&start_time,NULL);
	pre_time=start_time;

	while(1) {
		for(i=0;i<100;i++) msg0[i]=msg1[i]=msg2[i]=msg3[i]=mbf1[i]=mbf2[i]='\0';//initizlize message buffers
		sprintf(msg0,"network task: ");
		gettimeofday(&cur_time,NULL);
		elapsedtime=calclock(pre_time, cur_time);

		if(elapsedtime>REFRESH) { //update display window every REFRESH us
			pre_time=cur_time;	//replace previous time with current time

			//**************************************************************************************
			//obtain accumulated CPU time which is the sum of the 42 and 43'th fields of /proc/ppid/stat
			//**************************************************************************************
			//input the result of "cat /proc/ppid/stat" to "awk '{printf $42}'"
			sprintf(cmd,"cat /proc/%d/stat |awk '{printf $42}'",getpid());
			//input the result of "awk '{printf $42}'",i.e., the 42'th field, to ctime1 by means of pipe
			fo=popen(cmd,"r"); fscanf(fo,"%d",&ctime1); fclose(fo);
			//input the result of "cat /proc/ppid/stat" to "awk '{printf $43}'"
			sprintf(cmd,"cat /proc/%d/stat |awk '{printf $43}'",getpid());
			//input the result of "awk '{printf $42}'",i.e., the 42'th field, to ctime1 by means of pipe
			fo=popen(cmd,"r"); fscanf(fo,"%d",&ctime2); fclose(fo);
			//obtain accumulated CPU time through adding two fields and normalizing it in terms of second unit
			a=ctime1;a+=ctime2;a=a/100;

			//obtain accumulated service time of the differece between the starting and current times, and normalize it in terms of second unit
			stime=calclock(start_time, cur_time);stime=stime/1000000;

			//printf("service time = %1.3f [sec], CPU time =%1.3f [Sec]\n", stime,a);

			//make three messages to display on the window
			sprintf(mbf1,"pid : %d | ppid : %d,",getpid(),getppid());
			sprintf(mbf2," %1.1f/%1.1f",a,stime);
			strcat(msg0,mbf1);strcat(msg0,mbf2);
			sprintf(msg1,"This is Network task!");
			sprintf(msg2,"Insert host IP");
			sprintf(msg3,"Charge = ");

			//After clear the window, display four messages on the window
			XClearWindow(d,w);
			XDrawString(d,w,gc,5,20,msg0,sizeof(msg0));
			XDrawString(d,w,gc,15,45,msg1,sizeof(msg1));
			XDrawString(d,w,gc,15,65,msg2,sizeof(msg2));
			XDrawString(d,w,gc,15,85,msg3,sizeof(msg3));
        	XFlush (d);

		}
	}

	//close procedure for X-window
	XUnloadFont (d,f);
	XFreeGC(d,gc);
	XDestroyWindow(d,w);
    XCloseDisplay (d);
 }

long long  calclock( struct timeval clock_a, struct timeval clock_b ) 
{
	long long timedelay, temp, temp_n;
	if (clock_a.tv_usec >= clock_a.tv_usec) {
		temp = clock_b.tv_sec - clock_a.tv_sec;
		temp_n = clock_b.tv_usec - clock_a.tv_usec;
		timedelay = 1000000 * temp + temp_n;
	} else {
		temp = clock_b.tv_sec - clock_a.tv_sec - 1;
		temp_n = 1000000 + clock_b.tv_usec - clock_a.tv_usec;
		timedelay = 1000000 * temp + temp_n;
	}
	return timedelay;
}
