/***************************************************************************
 *            epda.h
 *
 *  Thu Oct 18 21:54:22 2007
 *  Copyright  2007  pchero
 *  pchero21@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
 
//define task number
//Notice you have to write all task names except DMB and MP3 with lowercase letters
#define CALL 						1
#define CONVERSATION 	2
#define SMS						3
//#define SSMS 					21
//#define MSMS					22
#define PBOOK 					4
#define MP3 						5
#define DMB						6
#define CAMERA 				7
#define WEB  						8
#define NETWORK 				9
#define MAIN 						10

#define TASKS 					11

//message code
#define REQUEST						0
#define RESPONSE						1
#define START								2
#define FINISH							3
#define MULTIPLESMSREQUEST	4
#define MULTIPLESMSRESPONSE	5

#define	FLOG		11
#define	CLOG		22
#define	CFLOG		33

#define TRUE	1
#define FALSE 0

// Message format: type(=DestinationTaskNumber)+text(SourceTaskNumber+code+body(.. ))
// Note that each ePDA service requires its own text format
struct MessageFormat{
	long int type; 		// equal to DestinationTaskNumber
	char text[BUFSIZ];	// Details are defined by TextFormat
};
struct SMSTextFormat{ //text format for the sms sending service
	int SourceTaskNumber;
	int code;		
	char RecipientName[50];	
	char RecipientNumber[50];
	char SenderName[50];	
	char SenderNumber[50];	
	char data[BUFSIZ-8-200];	//remaining date 
};
struct MovieTextFormat{ // text format for the movie relay service 
	int SourceTaskNumber;
	int code;	
	char url[50];		// destination site URL including path and filename as well
	char quality[50]; 	// source site URL including path and filename as well
	char fifo[50];		// the name of named pipe, that is, FIFO
	char data[BUFSIZ-8-150-4];//remaining date 
};
struct MSMSTextFormat {	// text format for the sms muliple sending service
	int SourceTaskNumber;
	int code;
	char RecipientName[50];
	char RecipientNumber[50];
	char SenderName[50];
	char SenderNumber[50];
	int NumberOfMessages;		// count of sms
	char ServiceTimeLogFileName[50];	// log file name
	char data[BUFSIZ - 8 - 200 - 4 - 50];	// remaining data
};
struct PBookTextFormat {	// text format for the pbook find name service
	int SourceTaskNumber;
	int code;
	char RequestName[50];			// request for name to number
	char RequestNumber[50];		// request for number to name
	char ResponseName[50];		// response for number to name
	char ResponseNumber[50];	// response for name to number
	char data[BUFSIZ - 8 - 200];	// remaining data
};
struct shared_data		// shared data structure for all associated processes
{
	int ase[TASKS];			// ase[i] keeps ASE(Accumulated Service Event) for the task i, so that its value is increased by only the task i, where i is 0,1,.., or (TASKS-2). However, ase[TASKS-1] meaning ASE for the main task keeps the sum of ASEs of (TASKS-1) tasks except for the main task, and its value is increased by all those (TASKS-1) tasks, which means that ase[TASKS-1] is just a shared data.
	struct timeval ast[TASKS];	// This is for AST(Accumulated Service Time). ast[i] is increased by only the task i, but ast[TASKS-1] is increased by all (TASKS-1) tasks except for the main task, which means that ast[TASKS-1] is just a shared data.
	int choosing[TASKS];
	int number[TASKS];
};
	

int mqid;		//keep the ID of the message queue created by main task
int smid;		// keep the ID of the semaphore create by main task.
int LogFlag = CFLOG; //default log flag meaning both console and file logging
int nrmessage = 0, nsmessage = 0; //numbers of internal messages received and sent,respectively
FILE *flog;		//file pointer for log file

//logging both sent and received messages which are identified by the term in the prefix parameter
void MessageLog(FILE *flog, char prefix[50], struct MessageFormat message) {
	struct SMSTextFormat *text;	//SMSTextFormat is enough because only destination/source task numbers and code are logged
	text=(struct SMSTextFormat *) message.text;
	if(LogFlag==CLOG || LogFlag==CFLOG)
		;
		//fprintf(stderr, "%s: Destination/Source Tasks = %d/%d, code = %d\n", prefix, message.type, text->SourceTaskNumber, text->code);
	if(LogFlag==FLOG || LogFlag==CFLOG) 
		//fprintf(flog, "%s: Destination/Source Tasks = %d/%d, code = %d\n", prefix, message.type, text->SourceTaskNumber, text->code);
	fflush(flog);		//write immediately the logging data in disk file 
}

//Copy a structured data block "b" of size "c" to "a" in which their stuctures may differ 
void StructCopy(char *a, char *b, int c) 
{
	int i;
	for (i = 0; i < BUFSIZ; i++) 
		*(a + i) = *(b + i);
}
